



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>MySQL 管理之道读书总结</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">MySQL 管理之道读书总结</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-16 15:09:20 </span>
						</div>
										<div class="post-content">
											
		<p>最近读了《MySQL 管理之道》一书，做了以下总结，希望对大家有所帮助。在这里非常感谢作者的辛勤付出。</p>
<ol><li><p>影响 MySQL 性能的因素：<br />
    影响 MySQL InnoDB 引擎性能的最主要因素就是磁盘 I/ O，目前磁盘都是机械方式运作的，主要体现在读写前寻找磁道的过程中。因此在单块磁盘遇到了I/ O瓶颈时，可以把磁盘升级为 RAID 或 SSD 固态硬盘来提升性能，<br />
    影响MySQL InnoDB 引擎性能的另一个因素就是内存，InnoDB 引擎在设计之初就是考虑用于大型、高负荷、高并发生产环境的，因此内存的大小直接反映了数据库的性能好坏。在 Buffer_ Pool 缓冲池中，涉及的参数为 innodb_ buffer_ pool_ size，它是 InnoDB 引擎中最重要的参数之一， 对 InnoDB 的性能有决定性的影响。默认的设置只有8MB，将其设置为60%~ 80%的内存。</p></li>
<li><p>运维工作中常用的性能分析工具：<br />
vmstat, sar, iostat, netstat,free, ps, top, mpstat.<br />
推荐 Linux 服务器性能监控工具：dstat。collectl 以及淘宝开源监控项目Tsar等。</p></li>
<li><p>在 MySQL5.6里，提供了快速预热Buffer_Pool缓冲池，只需要在 my.cnf 加入以下命令：<br />
<code>innodb_ buffer_ pool_ dump_ at_ shutdown = 1</code><br />
解释：在关闭时把热数据 dump 到本地磁盘。<br />
<code>innodb_ buffer_ pool_ dump_ now = 1</code><br />
解释：采用手工方式把热数据 dump 到本地磁盘。<br />
<code>innodb_ buffer_ pool_ load_ at_ startup = 1</code><br />
解释：在启动时把热数据加载到内存。<br />
<code>innodb_ buffer_ pool_ load_ now = 1</code><br />
解释：采用手工方式把热数据加载到内存。</p></li>
<li><p>验证主从数据一致性工具：Maatkit 开源工具包。其中mk-table-checksum 是用来检测 master 和 slave 上的表结构和数据是否一致。mk-table-sync 是在主从数据不一致时，用来修复的。注意，这两个 perl 脚本在运行时都会锁表，表的大小取决于执行的快慢，不要再高峰期间运行，可选择凌晨。</p></li>
<li><p>软件部分性能优化主要涉及到数据库表设计（范式，字段类型，存储引擎），SQL语句与索引，配置文件参数，操作系统，文件系统， MysQL版本以及体系架构。</p></li>
<li><p>设计表结构可以满足第三范式。但三范式最大的问题在于查询时 通常需要 join 很多表，而这会导致查询效率很低。所以有时候基于性能考虑，我们需要有意违反三范式，适度地做冗余，以达到提高查询效率的目的。 </p></li>
<li><p>字段类型的选取：主键强烈建议用 int 型。省空间，提高效率。根据需求选择最小整数类型。建表时时间类型优先选择 timestamp，具有自动更新时间的功能，而且只占用4字节。</p></li>
<li><p>在线更改表结构：pt-online-schema-change</p></li>
<li><p>MySQL 的锁具有一下几种形式：<br />
表级锁：开销小，加锁快；不会出现死锁；锁定粒度大，发生锁冲突的概率最高， 并发度最低。MyISAM引擎属于这种类型。<br />
行级锁：开销大，加锁慢；会出现死锁；锁定粒度最小，发生锁冲突的概率最低，并发度也最高。InnoDB引擎属于这种类型。<br />
页面锁：开销和加锁时间界于表锁和行锁之间；会出现死锁；锁定 粒度界于表锁和行锁之间，并发度一般。 NDB 属于这种类型。<br />
InnoDB存储引擎是通过给索引上的索引项加锁来实现 的，这就意味着：只有通过索引条件检索数据， InnoDB 才会使用行级锁，否则， InnoDB 将使用表锁。</p></li>
<li><p>两个事务都需要获得对方持有的排他锁才能继续完成事务，这种循环锁等待就是典型的死锁。发生死锁后，InnoDB一般都能自动检测到，它会让一个事务释放锁并回退，另一个事务则获得锁，继续完成事务。死锁是无法避免的，我们可以通过调整业务的逻辑来尽量减少死锁出现的概率。</p></li>
<li><p>尽量不要混合使用多种存储引擎，会带来复杂的问题。</p></li>
<li><p>MyISAM 和 InnoDB之间的主要区别有以下几点：<br />
MyISAM是非事务安全型的，而InnoDB是事务安全型的，也就是ACID事务支持；<br />
MyISAM锁是表级锁，锁开销最小，而InnoDB支持行级锁定，锁管理开销大，支持更好的并发写操作；·MyISAM支持全文索引，而InnoDB不支持全文索引，但在最新的5.6版本中已提供支持；<br />
MyISAM相对简单，管理方便，因此在效率上要优于InnoDB，小型应用可以考虑使用MyISAM；<br />
MyISAM表是保存成文件的形式，在跨平台的数据转移中使用MyISAM存储会省去不少的麻烦；<br />
InnoDB表比MyISAM表更安全，可以在保证数据不会丢失的情况下，切换非事务表到事务表。</p></li>
<li><p>事务的概念：ACID</p></li>
<li><p>事务的实现：MySQL在进行事务处理的时候使用的是日志先行的方式来保证事务可快速和持久运行的，也就是在写数据前，需要先写日志。当开始一个事务时，会记录该事务的一个LSN日志序列号；当执行事务时，会往InnoDB_Log_Buffer日志缓冲区里插入事务日志（redolog）；当事务提交时，会将日志缓冲区里的事务日志刷入磁盘。这个动作是由innodb_flush_log_at_trx_commit这个参数控制的。</p></li>
<li><p>事务的隔离级别。</p></li>
<li><p>联合索引遵循最左侧原则。<br />
SQL语句中包含or，不会使用索引，可以用union all 来替代。<br />
like 如果是模糊匹配，则不能使用索引。如果匹配的字符串是以明确的字符串开头的话，是可以的。<br />
去掉不必要的排序。<br />
用where子句替换having子句，having子句用于一些集合函数的比较，例如count() 等。<br />
字段使用函数，不能用到索引。<br />
致命的无引号会导致全表扫描，不会用到索引。<br />
主键的长度尽量不要太长；<br />
固定长度的字符字段应使用char或nchar类型；<br />
长度不固定的使用varchar或nvarchar。<br />
对于可有可无的字段应尽量提供一个默认值。</p></li>
<li><p>使用 on duplicate key update 解决主键冲突判断，冲突 update，不冲突 insert。</p></li>
<li><p>my.cnf配置文件调优。性能调试工具tuning-primer.sh</p></li>
<li><p>mydumper：一款高性能多线程的备份和恢复工具。</p></li>
<li><p>oneProxy分库分表。</p></li>
<li><p>Lepus 慢日志分析平台。</p></li>
<li><p>读/写分离的基本原理是：让master库处理事务增、删、改操作（INSERT、DELETE、UPDATE），而让slave库处理SELECT查询操作，replication数据库负责把数据变更同步到集群的slave库中。</p></li></ol>																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqvdldyq.html">php 小函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k5lzr8.html">荣品RP4412开发板烧写内核cannot load出错的原因</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z43en9.html">Java笔记7-多态父类静态</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdkp4v9.html">C&plus;&plus;设计模式-Proxy代理模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7d0meq.html">C&num; iis错误配置信息&lpar; 500&period;21 - Internal Server Error &rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q702ej8.html">winform控件</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gxe0eq.html">Java 线程异常处理器</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqd4dkxq.html">Android开发--RelativeLayout的应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8oz6kp9.html">【BZOJ-1452】Count    树状数组 套 树状数组</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x3v0w9.html">在ASP&period;NET项目中使用CKEditor &plus;CKFinder实现图片上传功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y5g70q.html">排列的Java递归语言实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj4zjeq.html">ubuntu环境下docker安装步骤</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me43y0q.html">【IOS 开发】Object - C 语法 之 流程控制</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rlro48.html">Visual Assist X 助手下载</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyv0z1jq.html">Tensorflow踩坑之tf&period;nn&period;bidirectional&lowbar;dynamic&lowbar;rnn（）报错 &OpenCurlyDoubleQuote;ValueError&colon; None values not supported&period;&rdquo;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmg1ee9.html">【LOJ】&num;2037&period; 「SHOI2015」脑洞治疗仪</a>
		</li>
						<li><a href="https://www.batexi.com/a/qloj276q.html">Android-ContentProvider简单的增删改查</a>
		</li>
						<li><a href="https://www.batexi.com/a/96m7yrj8.html">Ubuntu上开启Apache Rewrite功能的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2x3l2o9.html">Java虚拟机（二）：垃圾回收算法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvd675zq.html">SqlServer触发器的理解</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q25ed4xq.html">c&plus;&plus; primer 笔记  （一）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnv6m7j8.html">openstack安装-计算节点-neutron服务安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gj61l09.html">NodeMCU入门（1）：刷入At固件，透传数据到TcpServer和Yeelink平台</a>
			</li>
						<li><a href="https://www.batexi.com/a/95gl0zmq.html">020 &dollar;&period;each的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kj6pgj9.html">C&num;连接数据库MD5数据库加密</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnv6nmj8.html">POJ 2337 Catenyms&lpar;有向欧拉图&colon;输出欧拉路径&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7ove3e8.html">iOS企业版应用发布&lpar;部分低版本系统）无法安装到最新版app的问题-缓存导致</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m26jz6q.html">ES6 中的 Map和Set</a>
			</li>
						<li><a href="https://www.batexi.com/a/90r0d7n9.html">用js来实现那些数据结构02（数组篇02-数组方法）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25exvoq.html">java中thread的start&lpar;&rpar;和run&lpar;&rpar;的区别</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
